<?php
############################################################
# X-CART-SEO Mod :: http://code.google.com/p/x-cart-seo/
############################################################

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

$seo_exec = false;

## Defining array of url structures that need to be rewritten
$seo_regex_arr = array();
$seo_regex_arr[] = array('home.php','cat=','cat');
$seo_regex_arr[] = array('manufacturers.php','manufacturerid=','man');
$seo_regex_arr[] = array('product.php','productid=','prod');
$seo_regex_arr[] = array('pages.php','pageid=','pages');

## Testing REQUEST_URI, if url needs to be rewritten, $seo_exec will specify
## which type of url will need a rewrite
foreach($seo_regex_arr AS $v){
	if(strpos($_SERVER['REQUEST_URI'],$v[0])!==false){
		if(strpos($_SERVER['REQUEST_URI'],$v[1])!==false){
			$seo_exec = $v[2];
		}
		break;
	}
}

## If url is not scheduled for rewrite, and if user agent is a robot
## then remove references to the printable & sortable parts of the url
## and redirect bot to the new url structure
if(defined("IS_ROBOT") && !$seo_exec){
	$bot_url = $_SERVER["REQUEST_URI"];
	$bot_url = eregi_replace('-print-','-',$bot_url);
	$bot_url = eregi_replace('-(productcode|title|price|orderby)-','-',$bot_url);
	$bot_url = eregi_replace('-(up|down)-','-',$bot_url);
	$bot_url = preg_replace('/(.*)(-c-(?:[0-9]+)-p-(?:[0-9]+))(-pr-(?:[0-9]+)\.html)/','$1$2',$bot_url);
	$bot_url = preg_replace('/(.*)[?&]'.$XCART_SESSION_NAME.'=(?:[^&][\d\w]+)([&].*)*/','$1$2',$bot_url);
	if($bot_url!=$_SERVER["REQUEST_URI"]){
		header( "HTTP/1.1 301 Moved Permanently" );
		func_header_location($bot_url);
		exit;
	}
}

## Rewrite url as needed and redirect user to the new alias
if($seo_exec!==false){
	include_once $xcart_dir."/include/templater/plugins/outputfilter.seo.php";

	$seo_qs = array();
	foreach($_GET AS $k=>$v){ // $_GET has already been sanitized by X-Cart
		$seo_qs[] = $k.'='.$v;
	}
	$seo_qs = array(false,'',implode('&',$seo_qs),'','');

	$seo_url = false;
	if(AREA_TYPE=='C' && $HTTPS != "on" && $seo_enable && class_exists('seo_filter')) {
		$seo = new seo_filter;
		switch($seo_exec){
			case 'cat':
				$seo_url = $seo->_category_callback($seo_qs, true);
			break;
			case 'man':
				$seo_url = $seo->_manufacturer_callback($seo_qs, true);
			break;
			case 'prod':
				$seo_url = $seo->_product_callback($seo_qs, true);
			break;
			case 'pages':
				$seo_url = $seo->_pages_callback($seo_qs, true);
			break;
		}
	}

	if($seo_url){
		header( "HTTP/1.1 301 Moved Permanently" );
		func_header_location($seo_url);
		exit;
	}
}

unset($seo,$seo_exec,$seo_regex_arr,$seo_cat,$seo_page,
$seo_manufacturerid,$seo_productid,$seo_url,$seo_qs,$bot_url);

?>